`default_nettype none
module dsdfir(out, in, bcksynch, sdclock5, en);
output reg signed [11:0] out = 12'sb0;
input wire in;
input wire en;
input wire bcksynch;
input wire sdclock5;
reg [14:0] x = 15'b101010101010101;
reg [1:0] x0p14 = 2'b10;
reg [1:0] x1p13 = 2'b00;
reg [1:0] x2p12 = 2'b10;
reg [1:0] x3p11 = 2'b00;
reg [1:0] x4p10 = 2'b10;
reg [1:0] x5p9 = 2'b00;
reg [1:0] x6p8 = 2'b10;
reg x7d = 1'b00;
reg signed [7:0] yinterm = 8'sb0;
reg bcksynchd = 1'b0;

wire [7:0] sum;

assign sum = x0p14+(x1p13<<1)+x2p12+(x2p12<<1)+(x3p11<<2)+(x4p10<<2)+x4p10+(x5p9<<2)+(x5p9<<1)+(x6p8<<3)-x6p8+(x7d<<3);

always @ (posedge sdclock5) 
begin
	if (bcksynch && (!bcksynchd))
	begin
		if (en)
		begin
     			x[14:0] <= {in, x[14:1]};
		end
		else
		begin
			x[14:0] <= 15'b101010101010101;
		end
	end
	bcksynchd <= bcksynch;
// Berekening die gedaan moet worden, calculation that has to be done: 
// y <= 39*($signed(x[0]+2*x[1]+3*x[2]+4*x[3]+5*x[4]+6*x[5]+7*x[6]+8*x[7]+7*x[8]+6*x[9]+5*x[10]+4*x[11]+3*x[12]+2*x[13]+x[14])-32);
	x0p14 <= x[0]+x[14];
	x1p13 <= x[1]+x[13];
	x2p12 <= x[2]+x[12];
	x3p11 <= x[3]+x[11];
	x4p10 <= x[4]+x[10];
	x5p9 <= x[5]+x[9];
	x6p8 <= x[6]+x[8];
	x7d <= x[7];
     	yinterm <= $signed(sum)-32;
     	out <= (yinterm<<<5)+(yinterm<<<3)-yinterm;
end
endmodule
`default_nettype wire
